Index: uspace/app/nav/test/nav.c
===================================================================
--- uspace/app/nav/test/nav.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/test/nav.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,95 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <pcut/pcut.h>
+#include "../nav.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(nav);
+
+/** Create and destroy navigator. */
+PCUT_TEST(create_destroy)
+{
+	navigator_t *nav;
+	errno_t rc;
+
+	rc = navigator_create(UI_DISPLAY_NULL, &nav);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	navigator_destroy(nav);
+}
+
+/** navigator_get_active_panel() returns the active panel */
+PCUT_TEST(get_active_panel)
+{
+	navigator_t *nav;
+	panel_t *panel;
+	errno_t rc;
+
+	rc = navigator_create(UI_DISPLAY_NULL, &nav);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* First panel should be active at the beginning */
+	panel = navigator_get_active_panel(nav);
+	PCUT_ASSERT_EQUALS(nav->panel[0], panel);
+
+	navigator_destroy(nav);
+}
+
+/** navigator_switch_panel() switches to a different panel */
+PCUT_TEST(switch_panel)
+{
+	navigator_t *nav;
+	panel_t *panel;
+	errno_t rc;
+
+	rc = navigator_create(UI_DISPLAY_NULL, &nav);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* First panel should be active at the beginning */
+	panel = navigator_get_active_panel(nav);
+	PCUT_ASSERT_EQUALS(nav->panel[0], panel);
+
+	navigator_switch_panel(nav);
+
+	/* Second panel should be active now */
+	panel = navigator_get_active_panel(nav);
+	PCUT_ASSERT_EQUALS(nav->panel[1], panel);
+
+	navigator_switch_panel(nav);
+
+	/* First panel should be active again */
+	panel = navigator_get_active_panel(nav);
+	PCUT_ASSERT_EQUALS(nav->panel[0], panel);
+
+	navigator_destroy(nav);
+}
+
+PCUT_EXPORT(nav);
Index: uspace/app/nav/test/panel.c
===================================================================
--- uspace/app/nav/test/panel.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/test/panel.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,402 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <pcut/pcut.h>
+#include <stdio.h>
+#include <ui/ui.h>
+#include <vfs/vfs.h>
+#include "../panel.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(panel);
+
+/** Test response */
+typedef struct {
+	bool activate_req;
+	panel_t *activate_req_panel;
+} test_resp_t;
+
+static void test_panel_activate_req(void *, panel_t *);
+
+static panel_cb_t test_cb = {
+	.activate_req = test_panel_activate_req
+};
+
+/** Create and destroy panel. */
+PCUT_TEST(create_destroy)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** panel_set_cb() sets callback */
+PCUT_TEST(set_cb)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	errno_t rc;
+	test_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	panel_set_cb(panel, &test_cb, &resp);
+	PCUT_ASSERT_EQUALS(&test_cb, panel->cb);
+	PCUT_ASSERT_EQUALS(&resp, panel->cb_arg);
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Test panel_paint() */
+PCUT_TEST(paint)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_paint(panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** panel_ctl() returns a valid UI control */
+PCUT_TEST(ctl)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	ui_control_t *control;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	control = panel_ctl(panel);
+	PCUT_ASSERT_NOT_NULL(control);
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Test panel_kbd_event() */
+PCUT_TEST(kbd_event)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	ui_evclaim_t claimed;
+	kbd_event_t event;
+	errno_t rc;
+
+	/* Active panel should claim events */
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	event.type = KEY_PRESS;
+	event.key = KC_ESCAPE;
+	event.mods = 0;
+	event.c = '\0';
+
+	claimed = panel_kbd_event(panel, &event);
+	PCUT_ASSERT_EQUALS(ui_claimed, claimed);
+
+	panel_destroy(panel);
+
+	/* Inactive panel should not claim events */
+
+	rc = panel_create(window, false, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	event.type = KEY_PRESS;
+	event.key = KC_ESCAPE;
+	event.mods = 0;
+	event.c = '\0';
+
+	claimed = panel_kbd_event(panel, &event);
+	PCUT_ASSERT_EQUALS(ui_unclaimed, claimed);
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Test panel_pos_event() */
+PCUT_TEST(pos_event)
+{
+}
+
+/** panel_set_rect() sets internal field */
+PCUT_TEST(set_rect)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 1;
+	rect.p0.y = 2;
+	rect.p1.x = 3;
+	rect.p1.y = 4;
+
+	panel_set_rect(panel, &rect);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.x, panel->rect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.y, panel->rect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.x, panel->rect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.y, panel->rect.p1.y);
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** panel_is_active() returns panel activity state */
+PCUT_TEST(is_active)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_TRUE(panel_is_active(panel));
+	panel_destroy(panel);
+
+	rc = panel_create(window, false, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_FALSE(panel_is_active(panel));
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** panel_activate() activates panel */
+PCUT_TEST(activate)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, false, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(panel_is_active(panel));
+	rc = panel_activate(panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_TRUE(panel_is_active(panel));
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** panel_deactivate() deactivates panel */
+PCUT_TEST(deactivate)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(panel_is_active(panel));
+	panel_deactivate(panel);
+	PCUT_ASSERT_FALSE(panel_is_active(panel));
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** panel_activate_req() sends activation request */
+PCUT_TEST(activate_req)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	panel_t *panel;
+	errno_t rc;
+	test_resp_t resp;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = panel_create(window, true, &panel);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	panel_set_cb(panel, &test_cb, &resp);
+
+	resp.activate_req = false;
+	resp.activate_req_panel = NULL;
+
+	panel_activate_req(panel);
+	PCUT_ASSERT_TRUE(resp.activate_req);
+	PCUT_ASSERT_EQUALS(panel, resp.activate_req_panel);
+
+	panel_destroy(panel);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+static void test_panel_activate_req(void *arg, panel_t *panel)
+{
+	test_resp_t *resp = (test_resp_t *)arg;
+
+	resp->activate_req = true;
+	resp->activate_req_panel = panel;
+}
+
+PCUT_EXPORT(panel);
Index: uspace/app/nav/types/menu.h
===================================================================
--- uspace/app/nav/types/menu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/types/menu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/**
+ * @file Navigator menu types
+ */
+
+#ifndef TYPES_MENU_H
+#define TYPES_MENU_H
+
+#include <ui/menubar.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+
+/** Navigator menu callbacks */
+typedef struct nav_menu_cb {
+	/** File / Open */
+	void (*file_open)(void *);
+	/** File / Exit */
+	void (*file_exit)(void *);
+} nav_menu_cb_t;
+
+/** Navigator menu */
+typedef struct nav_menu {
+	/** UI */
+	ui_t *ui;
+	/** Containing window */
+	ui_window_t *window;
+	/** Menu bar */
+	ui_menu_bar_t *menubar;
+	/** Callbacks */
+	nav_menu_cb_t *cb;
+	/** Callback argument */
+	void *cb_arg;
+} nav_menu_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/nav/types/nav.h
===================================================================
--- uspace/app/nav/types/nav.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/types/nav.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/**
+ * @file Navigator types
+ */
+
+#ifndef TYPES_NAV_H
+#define TYPES_NAV_H
+
+#include <ui/fixed.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+
+enum {
+	navigator_panels = 2
+};
+
+/** Navigator */
+typedef struct navigator {
+	/** User interface */
+	ui_t *ui;
+	/** Window */
+	ui_window_t *window;
+	/** Fixed layout */
+	ui_fixed_t *fixed;
+	/** Menu */
+	struct nav_menu *menu;
+	/** Panels */
+	struct panel *panel[navigator_panels];
+} navigator_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/nav/types/panel.h
===================================================================
--- uspace/app/nav/types/panel.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/types/panel.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,87 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/**
+ * @file Navigator panel types
+ */
+
+#ifndef TYPES_PANEL_H
+#define TYPES_PANEL_H
+
+#include <gfx/color.h>
+#include <gfx/coord.h>
+#include <ui/filelist.h>
+#include <ui/window.h>
+#include <stdint.h>
+
+/** Navigator panel
+ *
+ * This is a custom UI control.
+ */
+typedef struct panel {
+	/** Base control object */
+	struct ui_control *control;
+
+	/** Containing window */
+	ui_window_t *window;
+
+	/** Callbacks */
+	struct panel_cb *cb;
+
+	/** Callback argument */
+	void *cb_arg;
+
+	/** Panel rectangle */
+	gfx_rect_t rect;
+
+	/** Panel color */
+	gfx_color_t *color;
+
+	/** Active border color */
+	gfx_color_t *act_border_color;
+
+	/** @c true iff the panel is active */
+	bool active;
+
+	/** File list */
+	ui_file_list_t *flist;
+} panel_t;
+
+/** Panel callbacks */
+typedef struct panel_cb {
+	/** Request panel activation */
+	void (*activate_req)(void *, panel_t *);
+} panel_cb_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/netecho/comm.c
===================================================================
--- uspace/app/netecho/comm.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/netecho/comm.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -52,5 +52,4 @@
 static udp_t *udp;
 static udp_assoc_t *assoc;
-static inet_ep_t remote;
 
 #define RECV_BUF_SIZE 1024
@@ -185,5 +184,5 @@
 errno_t comm_send(void *data, size_t size)
 {
-	errno_t rc = udp_assoc_send_msg(assoc, &remote, data, size);
+	errno_t rc = udp_assoc_send_msg(assoc, NULL, data, size);
 	if (rc != EOK)
 		return EIO;
Index: uspace/app/netecho/meson.build
===================================================================
--- uspace/app/netecho/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/netecho/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('comm.c', 'netecho.c')
Index: uspace/app/nterm/meson.build
===================================================================
--- uspace/app/nterm/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/nterm/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('conn.c', 'nterm.c')
Index: uspace/app/ofw/doc/doxygroups.h
===================================================================
--- uspace/app/ofw/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/ofw/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,4 @@
+/** @addtogroup ofw ofw
+ * @brief Tool for printing the OpenFirmware device tree
+ * @ingroup apps
+ */
Index: uspace/app/ofw/meson.build
===================================================================
--- uspace/app/ofw/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/ofw/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,32 @@
+#
+# Copyright (c) 2023 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+platform_specific = true
+
+deps = [ 'ofw' ]
+src = files('ofw.c')
Index: uspace/app/ofw/ofw.c
===================================================================
--- uspace/app/ofw/ofw.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/ofw/ofw.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,182 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ofw
+ * @{
+ */
+
+/**
+ * @file
+ * @brief Tool for printing the OpenFirmware device tree
+ */
+
+#include <errno.h>
+#include <ofw.h>
+#include <stdbool.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+
+#define NAME	"ofw"
+
+#define MAX_NAME_LENGTH 1024
+
+static void syntax_print(void);
+static errno_t ofw_print_subtree(const char *, bool);
+static errno_t ofw_print_properties(const char *);
+
+int main(int argc, char **argv)
+{
+	errno_t rc;
+	const char *path = "/";
+	bool verbose = false;
+
+	--argc;
+	++argv;
+
+	while (argc > 0 && argv[0][0] == '-') {
+		if (str_cmp(argv[0], "-p") == 0) {
+			--argc;
+			++argv;
+			if (argc < 1) {
+				printf("Option argument missing.\n");
+				return 1;
+			}
+
+			path = argv[0];
+			--argc;
+			++argv;
+		} else if (str_cmp(argv[0], "-v") == 0) {
+			--argc;
+			++argv;
+
+			verbose = true;
+		} else {
+			syntax_print();
+			return 1;
+		}
+	}
+
+	if (argc != 0) {
+		syntax_print();
+		return 1;
+	}
+
+	rc = ofw_print_subtree(path, verbose);
+	if (rc != EOK)
+		return 1;
+
+	return 0;
+}
+
+static void syntax_print(void)
+{
+	printf("syntax: %s [<options>]\n", NAME);
+	printf("options:\n"
+	    "\t-v        Verbose mode (print properties and their values)\n"
+	    "\t-p <path> Only print devices under <path>\n");
+}
+
+/** List OpenFirmware device nodes under a specific node.
+ *
+ * @param path Path of node where to start printing
+ * @param verbose If @c true, print properties
+ * @return EOK on success or an error code
+ */
+static errno_t ofw_print_subtree(const char *path, bool verbose)
+{
+	char *subpath;
+	ofw_child_it_t it;
+	errno_t rc;
+
+	printf("%s\n", path);
+
+	if (verbose) {
+		rc = ofw_print_properties(path);
+		if (rc != EOK)
+			return rc;
+	}
+
+	rc = ofw_child_it_first(&it, path);
+	while (!ofw_child_it_end(&it)) {
+		rc = ofw_child_it_get_path(&it, &subpath);
+		if (rc != EOK)
+			goto error;
+
+		rc = ofw_print_subtree(subpath, verbose);
+		if (rc != EOK)
+			goto error;
+
+		free(subpath);
+		subpath = NULL;
+
+		ofw_child_it_next(&it);
+	}
+
+	ofw_child_it_fini(&it);
+	return EOK;
+error:
+	if (subpath != NULL)
+		free(subpath);
+	ofw_child_it_fini(&it);
+	return rc;
+}
+
+static errno_t ofw_print_properties(const char *ofwpath)
+{
+	const char *propname;
+	const uint8_t *propval;
+	size_t val_sz;
+	ofw_prop_it_t it;
+	errno_t rc;
+	size_t i;
+
+	rc = ofw_prop_it_first(&it, ofwpath);
+	if (rc != EOK)
+		return rc;
+
+	while (!ofw_prop_it_end(&it)) {
+		propname = ofw_prop_it_get_name(&it);
+		printf("'%s' =", propname);
+
+		propval = ofw_prop_it_get_data(&it, &val_sz);
+
+		for (i = 0; i < val_sz; i++)
+			printf(" %02x", propval[i]);
+
+		printf(" ('%*s')\n", (int)val_sz - 1, (char *)propval);
+		ofw_prop_it_next(&it);
+	}
+
+	ofw_prop_it_fini(&it);
+	return EOK;
+}
+
+/**
+ * @}
+ */
Index: uspace/app/ping/meson.build
===================================================================
--- uspace/app/ping/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/ping/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('ping.c')
Index: uspace/app/sysinst/sysinst.c
===================================================================
--- uspace/app/sysinst/sysinst.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/sysinst/sysinst.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2018 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,5 +62,6 @@
  * in Grub notation).
  */
-#define DEFAULT_DEV "devices/\\hw\\sys\\00:01.0\\ata-c1\\d0"
+#define DEFAULT_DEV_0 "devices/\\hw\\sys\\00:01.1\\c0d0"
+#define DEFAULT_DEV_1 "devices/\\hw\\sys\\00:01.0\\ata1\\c0d0"
 //#define DEFAULT_DEV "devices/\\hw\\pci0\\00:01.2\\uhci_rh\\usb01_a1\\mass-storage0\\l0"
 /** Volume label for the new file system */
@@ -79,8 +80,34 @@
 #define BOOT_BLOCK_IDX 0 /* MBR */
 
+static const char *default_devs[] = {
+	DEFAULT_DEV_0,
+	DEFAULT_DEV_1,
+	NULL
+};
+
 static const char *sys_dirs[] = {
 	"/cfg",
-	"/data"
+	"/data",
+	NULL
 };
+
+/** Check the if the destination device exists.
+ *
+ * @param dev Disk device
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t sysinst_check_dev(const char *dev)
+{
+	service_id_t sid;
+	errno_t rc;
+
+	rc = loc_service_get_id(dev, &sid, 0);
+	if (rc != EOK)
+		return rc;
+
+	(void)sid;
+	return EOK;
+}
 
 /** Label the destination device.
@@ -361,5 +388,5 @@
 
 	printf("sysinst_copy_boot_blocks: block_init.\n");
-	rc = block_init(sid, 512);
+	rc = block_init(sid);
 	if (rc != EOK)
 		return rc;
@@ -490,6 +517,20 @@
 int main(int argc, char *argv[])
 {
-	const char *dev = DEFAULT_DEV;
-	return sysinst_install(dev);
+	unsigned i;
+	errno_t rc;
+
+	i = 0;
+	while (default_devs[i] != NULL) {
+		rc = sysinst_check_dev(default_devs[i]);
+		if (rc == EOK)
+			break;
+	}
+
+	if (default_devs[i] == NULL) {
+		printf("Cannot determine installation device.\n");
+		return 1;
+	}
+
+	return sysinst_install(default_devs[i]);
 }
 
Index: uspace/app/taskbar-cfg/doc/doxygroups.h
===================================================================
--- uspace/app/taskbar-cfg/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/taskbar-cfg/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,4 @@
+/** @addtogroup taskbar-cfg taskbar-cfg
+ * @brief Taskbar configuration utility (UI)
+ * @ingroup apps
+ */
